//
// Written by Xeon Xarid of WintersEbb
// March 28th, 2005
// v1.1 - May 6th
//      -- Changed code to find Item tab in vendors
//

var Version = "BuyLow-SellHigh v1.1  May 6th 2005"

// Internal Variables, change at own risk

//raw
var h = new myHandlers();
var Go;
var opmAll = (opmChatWnd | opmConsole);
var Start;
var szSchema;
var First = true;
var Sell = false;
var pdwDxp3D, pdwDyp3D;
var pxtIsOpen;
var chatwin;
var buyACO;
var sellACO;
var buyTarget;
var sellTarget;

//main
var RunningClock;
var DebugFlag = false;
var InitialViolet;
var TotalViolet;
var BurdenFull;
var BurdenCurrent;
var currentCash;
var VendorOpen = false;
var Vendor;
var VendorMcmBuy;
var VendorMaxBuy;
var VendorFractBuy = 1;
var VendorFractSell = 1;
var ItemCoaca;


var introText = "Double Click vendor and open desired Item panel.\n Select the item you wish to buy from the vendor\n and hit the: Set Buy Target button\n Then select the items in your pack you wish to sell\n and hit the: Sell Target button"

function MyHandlers_OnControlEvent(szPanel, szControl, dictSzValue)
{
	var BoolCheck;
	if (szPanel == "BuyLow_SellHigh")
	{
		switch (szControl)
		{
		case 'btnBuy':
			SetBuyTarget();
			break;

		case 'btnSell':
			SetSellTarget();
			break;

		case 'btnStart':
			if (!VendorOpen)
			{
				skapi.OutputLine("--------------------------------------------------------------------", opmChatWnd);
				skapi.OutputLine(" ERROR: No Vendor selected, try double clicking in the Vendor again", opmChatWnd);
				skapi.OutputLine("--------------------------------------------------------------------", opmChatWnd);
				return;
			}
			if (sellACO == null || sellACO == undefined)
			{
				skapi.OutputLine("--------------------------------------------------------------------", opmChatWnd);
				skapi.OutputLine(" ERROR: Please select stack of items to sell", opmChatWnd);
				skapi.OutputLine("--------------------------------------------------------------------", opmChatWnd);
				return;
			}
			if (buyACO == null || buyACO == undefined)
			{
				skapi.OutputLine("--------------------------------------------------------------------", opmChatWnd);
				skapi.OutputLine(" ERROR: Please select Vendor item to buy", opmChatWnd);
				skapi.OutputLine("--------------------------------------------------------------------", opmChatWnd);
				return;
			}
			Sell = true;
			skapi.OutputLine("----------------------------------------------------------------------", opmChatWnd);
			skapi.OutputLine(" Selling "+sellTotal+" "+sellTarget+" and buying "+buyTarget, opmChatWnd);
			skapi.OutputLine("----------------------------------------------------------------------", opmChatWnd);

			break;

		case 'chkDebugFlag':
			DebugFlag = (dictSzValue('chkDebugFlag')=="True");
			skapi.OutputLine("Edited: Option - DebugFlag now " + dictSzValue('chkDebugFlag'), opmAll);
			break;

		case 'btnQuit':
			Go = false;
			Sell = false;
			break;

		default:
			break;
		}			  	
	}
}


function StackItems(aco)
{
	if (DebugFlag) skapi.OutputLine("StackItems: "+aco.szName, opmChatWnd);

	var itemName = aco.szName;
	var newACF = skapi.AcfNew();
	newACF.szName = itemName;
	newACF.olc = olcInventory;
	// Build collection from main pack only
	var NameColl = newACF.CoacoGet(skapi.acoChar.coacoContents);

	if (DebugFlag) skapi.OutputLine("NameColl.Count: "+NameColl.Count, opmChatWnd);

	if (NameColl.Count < 2) return;

	// stack 'em up!
	while (NameColl.Count > 1)
	{
		var nameAco = NameColl.Item(0);
		var destAco = NameColl.Item(1);
		if (nameAco.citemStack == nameAco.citemMaxStack)
		{
			NameColl.removeAco(nameAco);
		}
		else if (destAco.citemStack == destAco.citemMaxStack)
		{
			NameColl.removeAco(nameAco);
		}
		else if ((nameAco.citemStack + destAco.citemStack) <= nameAco.citemMaxStack)
		{
			nameAco.MoveToStack(destAco);
			NameColl.removeAco(nameAco);
		}
		else
		{
			nameAco.MoveToStack(destAco);
			NameColl.removeAco(destAco);
		}
		skapi.WaitEvent(1000,wemNormal,evidOnAdjustStack);
	}
}

function MyHandlers_OnApproachVendor(acoMerchant, mcmBuy, cpyMaxBuy, fractBuy, fractSell, coaco) {
	VendorOpen	= true;
	Vendor		= acoMerchant;
	VendorMcmBuy	= mcmBuy;
	VendorMaxBuy	= cpyMaxBuy;
	VendorFractBuy	= fractBuy;
	VendorFractSell	= fractSell;
	ItemCoaca	= coaco;
	return;
} 

function myHandlers()
{
// 	this.OnTell = MyHandlers_OnTell;
 	this.OnControlEvent = MyHandlers_OnControlEvent;
 	this.OnApproachVendor = MyHandlers_OnApproachVendor;
// 	this.OnAddToInventory = MyHandlers_OnAddToInventory;
}
 
function fAddHandlers()
{
// 	skapi.AddHandler(evidOnTell,h);
 	skapi.AddHandler(evidOnControlEvent,h);
 	skapi.AddHandler(evidOnApproachVendor,h);
// 	skapi.AddHandler(evidOnAddToInventory,h);
} 
 
function fRemoveHandlers()
{
// 	skapi.RemoveHandler(evidOnTell,h);
 	skapi.RemoveHandler(evidOnControlEvent,h);
 	skapi.RemoveHandler(evidOnApproachVendor,h);
// 	skapi.RemoveHandler(evidOnAddToInventory,h);
}

function SetBuyTarget()
{
	buyACO = skapi.acoSelected;
	if (buyACO == null || buyACO == "")
	{
		skapi.OutputLine("ERROR: You must first select the item in the vendor window you wish to buy", opmChatWnd);
		return;
	}
	buyTarget = buyACO.szName;
	buyCost = (buyACO.cpyValue * VendorFractSell);
	if (buyTarget.indexOf("Trade Note") >= 0)
		buyCost = (buyACO.cpyValue * 1.15);
	skapi.OutputLine("Buy target set to: "+ buyTarget, opmChatWnd);
	skapi.SetControlProperty("BuyLow_SellHigh", "bTarget", "Text", buyTarget)
	if (DebugFlag) 	skapi.OutputLine("buyTarget: "+buyTarget+" buyCost: "+buyCost, opmChatWnd);
}

function SetSellTarget()
{
	sellACO = skapi.acoSelected;
	if (sellACO == null || sellACO == "")
	{
		skapi.OutputLine("ERROR: You must first select the item in your pack you wish to sell", opmChatWnd);
		return;
	}
	sellTarget = sellACO.szName;
	sellTotal = sellACO.citemStack;
	sellCost = (sellACO.cpyValue * VendorFractBuy) / sellTotal;
	skapi.OutputLine("Sell target set to: "+ sellTarget + " ("+sellTotal+")", opmChatWnd);
	skapi.SetControlProperty("BuyLow_SellHigh", "sTarget", "Text", sellTarget)
	if (DebugFlag) 	skapi.OutputLine("sellTarget: "+sellTarget+" sellTotal: "+sellTotal+" sellCost: "+sellCost, opmChatWnd);
}

function BuySell()
{

	if (!Go || !Sell) return;

	var numberSold = 0;

	//if (DebugFlag) 	skapi.OutputLine("BS:buyTarget: "+buyTarget+"     buyCost: "+buyCost, opmChatWnd);
	//if (DebugFlag) 	skapi.OutputLine("BS:sellTarget: "+sellTarget+"   sellTotal: "+sellTotal+"     sellCost: "+sellCost, opmChatWnd);
	//if (DebugFlag) 	skapi.OutputLine("BS:Vendor: "+Vendor.szName+"    FractBuy: "+VendorFractBuy, opmChatWnd);

	while (numberSold < sellTotal)
	{

		if (DebugFlag) skapi.OutputLine("Sold::Total     "+numberSold+" :: "+sellTotal, opmChatWnd);

		skapi.WaitEvent(500,wemSpecific,evidOnControlProperty);
		if (!Sell) return;

		//////////////////////////////////////////
		// First do the SELL part of the action //
		//////////////////////////////////////////

		// Make sure we still have sellACO items left to sell
		if (sellACO == null || sellACO.citemStack <= 0)
		{
			Sell = false;
			return;
		}

		// Make sure we have a vendor to sell to
		if (!VendorOpen || Vendor == null || Vendor == undefined)
		{
			Sell = false;
			skapi.OutputLine("ERROR: No Vendor to sell to, try reselecting the Vendor", opmChatWnd);
		}

		// get pack space available
		var freePackSpace = 100 - (skapi.acoChar.cItemContents);
		if (DebugFlag) skapi.OutputLine("freePack Space:  " + freePackSpace, opmChatWnd);

		// number of slots each item sold takes up
		var minPackSpace = sellCost / 10000;
		if (DebugFlag) skapi.OutputLine("minPack Space:  " + minPackSpace, opmChatWnd);

		// How many to sell to almost fill up free pack space
		var sellNumber = Math.floor(freePackSpace/minPackSpace);
		if (DebugFlag) skapi.OutputLine("sellNumber:  " + sellNumber, opmChatWnd);

		if (sellNumber < 1)
		{
			skapi.OutputLine("ERROR: You need more pack Space! : free up " + minPackSpace, opmChatWnd);
			Sell = false;
			return;
		}

		currentCash = skapi.cpyCash;

		var currentStackSize = sellACO.citemStack;
		if (currentStackSize < sellNumber)
		{
			if (DebugFlag) skapi.OutputLine("currentStack < sellNumber:  "+sellNumber+" :: "+currentStackSize, opmChatWnd);
			sellNumber = currentStackSize;
		}
		skapi.SelectAco(Vendor);
		skapi.WaitEvent(100,wemFullTimeout);

		skapi.SelectAco(sellACO);
		skapi.WaitEvent(100,wemFullTimeout);
		skapi.SetStackCount(sellNumber);
		if (DebugFlag) skapi.OutputLine("SetStackCount:  " + sellNumber, opmChatWnd);
		sellACO.MoveToPack(0,0,false);
		skapi.WaitEvent(10000,wemSpecific,evidOnAddToInventory);
		if (DebugFlag) skapi.OutputLine("Moved Stack to 0,0", opmChatWnd);
		//BuyerPartialItemFilter.CoacoGet().Item(0)
		//skapi.acoChar.coacoContents

		var tempSell = skapi.AcfNew();
		tempSell.szName = sellTarget;
		tempSell.olc = olcInventory;
		var tempObj = tempSell.CoacoGet().Item(0);
		if (DebugFlag) skapi.OutputLine("tempObj:  " + tempObj.szName + " ("+tempObj.citemStack+")", opmChatWnd);

		tempObj.MoveToStack(Vendor);

		Push_BuySell_Button();
		skapi.WaitEvent(10000,wemSpecific,evidOnAddToInventory);

		if (currentCash == skapi.cpyCash)
		{
			skapi.OutputLine("ERROR: Failed to buy item, stoping script", opmChatWnd);
			Sell = false;
			return;
		}

		// make sure to update the number sold
		numberSold += sellNumber;

		if (DebugFlag) skapi.OutputLine("Sold::Total     "+numberSold+" :: "+sellTotal, opmChatWnd);


		/////////////////////////////////////
		// Ok, now it's time to BUY stuff  //
		/////////////////////////////////////

		Select_Items();
		if (DebugFlag) skapi.OutputLine("On Items tab", opmChatWnd);

		skapi.SelectAco(buyACO);
		skapi.WaitEvent(100,wemFullTimeout);

		if (DebugFlag) skapi.OutputLine("Selected: "+buyACO.szName, opmChatWnd);

		currentCash = skapi.cpyCash;

		var buyNumber = Math.floor(currentCash / buyCost);

		if (DebugFlag) skapi.OutputLine("cash: "+currentCash+"   buyNumber: "+buyNumber+"   buyCost: "+buyCost, opmChatWnd);

		skapi.SetStackCount(buyNumber);

		//if (skapi.fInChatBuffer)
		//	skapi.Keys("{Tab}", kmoClick);
		//skapi.Keys("{SplitSelected}");
		//skapi.Keys(buyNumber);

		if (DebugFlag) skapi.OutputLine("after SplitSelected", opmChatWnd);

		Push_BuySell_Button();
		skapi.WaitEvent(10000,wemSpecific,evidOnAddToInventory);

		if (DebugFlag) skapi.OutputLine("cash: "+currentCash+"   cpyCash: "+skapi.cpyCash, opmChatWnd);

		//if (currentCash == skapi.cpyCash)
		//{
		//	skapi.OutputLine("ERROR: Failed to buy item, stoping script", opmChatWnd);
		//	Sell = false;
		//	return;
		//}

		StackItems(buyACO);
	}

	Sell = false;
	skapi.SetControlProperty("BuyLow_SellHigh", "sTarget", "Text", "None")
	sellACO = null;

	skapi.OutputLine("----------------------------------------------", opmChatWnd);
	skapi.OutputLine("Done selling "+sellTotal+" "+sellTarget, opmChatWnd);
	skapi.OutputLine("----------------------------------------------", opmChatWnd);
}

function Push_BuySell_Button()
{
	var VertAdj = skapi.clrPixel(-321,-88) ? skapi.dypWindow/4-34 : 0;
	var HorzOffset = skapi.clrPixel(-318,-184-VertAdj) ? -33 : -342;
	var VertOffset = -161 - VertAdj;

//      skapi.MouseMove(-342,-289);
//      skapi.MouseButton(ibuttonLeft);

	//if (DebugFlag) skapi.OutputLine("Buy/Sell Button: VertAdj: " + VertAdj + "  HorzOffset: " + HorzOffset + "  VertOffset: " + VertOffset, opmAll);

	skapi.MouseMove(HorzOffset,VertOffset);    // Move mouse to buy or sell button (same location)
	skapi.MouseButton(ibuttonLeft);
}

function Select_Items()
{
	var VertAdj = skapi.clrPixel(-321,-88) ? skapi.dypWindow/4-34 : 0;
	var HorzOffset = skapi.clrPixel(-318,-184-VertAdj) ? -660 : -962;
	var VertOffset = -195 - VertAdj;
	HorzOffset = 20;

//      skapi.MouseMove(-962,-355);
//      skapi.MouseButton(ibuttonLeft);

	//if (DebugFlag) skapi.OutputLine("Items: VertAdj: " + VertAdj + "  HorzOffset: " + HorzOffset + "  VertOffset: " + VertOffset, opmAll);

	skapi.MouseMove(HorzOffset,VertOffset);    // Move mouse to Items tab
	skapi.MouseButton(ibuttonLeft);
}



function Initialise()
{
 	skapi.OutputLine(Version + " - Begin Macro" , opmAll,13);
 	skapi.OutputLine("Welcome " + skapi.szName , opmAll,13);

	pdwDxp3D = skapi.PdwMemlocFromSz("3DAreaWidth");
	pdwDyp3D = skapi.PdwMemlocFromSz("3DAreaHeight");
	pxtIsOpen = skapi.PxtNew(0, 0, 0x00000810, 0x0073869C);

	chatwin = -1 * (66 + (skapi.dypRes / 4));  //-258
 	//skapi.OutputLine("dypRes " + skapi.dypRes + " chatwin " + chatwin);

 	SetupSchema();
 	skapi.ShowControls(szSchema, First);

 	Go = true;

	currentCash = skapi.cpyCash;
        StartPackCount = skapi.acoChar.cItemContents;

	RunningClock = Start.cmsec;
        LastActionComplete = Start.cmsec/1000;

 	skapi.OutputLine("Date : " + Date(), opmAll,14);
 	skapi.OutputLine("Starting with " + StartPackCount + " items in Main Pack", opmAll, 13);

}
 

function main() 
{ 	
	var KeepRunning = true;
	var LoggedTime = skapi.TimerNew();
	var LogTime = 0;
        Start = skapi.TimerNew();

	fAddHandlers();
	while (KeepRunning)
	{
		Initialise();
		while (Go)
		{
		var e;
		try {
			if ( Sell && (buyACO != null) && (sellACO != null) && VendorOpen ) 
			{
				BuySell();
                        }    
                        skapi.WaitEvent(1000,wemNormal);

                    }
		catch (e)
                    {
			if (skapi.plig == pligNotRunning)
			{
                            Go = false;
			}
                    }
		}
		First = false;
 		skapi.RemoveControls("BuyLow_SellHigh");
		KeepRunning = false;
 	}
 	fRemoveHandlers();
 	skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - " + Version + " - End Macro" , opmAll);
}
 
function SetupSchema()
{
  szSchema =
  	"<view icon='5432' title='BuyLow_SellHigh' \n" + 
  	"  width='280' height='220'>\n" + 
  	"  <control progid='DecalControls.FixedLayout'>\n" + 

  	"      <control name='iText' progid='DecalControls.StaticText' text='" + introText + "' left='10' top='0' width='280' height='80' />\n" +

  	"      <control name='btnBuy' progid='DecalControls.PushButton' text='Set Buy Target' left='10' top='80' width='80' height='20' />\n" +
  	"      <control name='bTarget' progid='DecalControls.StaticText' text='' left='100' top='80' width='100' height='20' />\n" +

  	"      <control name='btnSell' progid='DecalControls.PushButton' text='Set Sell Target' left='10' top='110' width='80' height='20' />\n" +
  	"      <control name='sTarget' progid='DecalControls.StaticText' text='' left='100' top='110' width='100' height='20' />\n" +

  	"      <control name='chkDebugFlag' progid='DecalControls.CheckBox' text='Debug' left='170' top='158' width='70' height='20' checked='" + DebugFlag + "' />\n" +

  	"      <control name='btnStart' progid='DecalControls.PushButton' text='START' left='10' top='155' width='50' height='20' />\n" + 

  	"      <control name='btnQuit'  progid='DecalControls.PushButton' text='Quit' left='90' top='155' width='50' height='20' />\n" + 
  	"  </control>\n" + 
 	"</view>";
}
